dpwfh874876
2018-03-18 04:30
浏览 38
已采纳

为什么restore()在嵌套的延迟函数中不起作用?

I am testing panic/recover in Golang. This simple program works as expected:

package main

import "fmt"

func printRecover() {
    r := recover()
    fmt.Println("Recovered:", r)
}

func main() {
    defer printRecover()

    panic("OMG!")
}

Output:

Recovered: OMG!

However, if I wrap the function printRecover() in a bigger deferred function:

package main

import "fmt"

func printRecover() {
    r := recover()
    fmt.Println("Recovered:", r)
}

func main() {
    defer func() {
        printRecover()
    }()

    panic("OMG!")
}

It does not recover and let the panic go through:

Recovered: <nil>
panic: OMG!

goroutine 1 [running]:
main.main()
    /tmp/sandbox898315096/main.go:15 +0x60

Can someone explain the difference?

  • 点赞
  • 写回答
  • 关注问题
  • 收藏
  • 邀请回答

1条回答 默认 最新

  • douao1854 2018-03-18 04:58
    已采纳

    It is because recover will be nil if not directly called by deferred function

    Here is excerpt from golang spec

    The return value of recover is nil if any of the following conditions holds:

    1. panic's argument was nil;
    2. the goroutine is not panicking;
    3. recover was not called directly by a deferred function.

    For more info check the full spec here

    点赞 评论

相关推荐 更多相似问题